<!---//--------------------------------------------------------------------
	Name:		view_bs.cfm
	Author:		Arowolo Michael .A.
	Created:	04/04/2008
	Updated:	04/04/2008
	Copyright:	(c) 2008	
	Purpose:	view balance sheet
---------------------------------------------------------------------//---> 
<table width="100%" border="0" cellspacing="2" cellpadding="2">
  <tr>
    <td>
<!--- use the current month by default --->
<cfif not(structkeyexists(url,'param1'))>
	<cfset url.param1 =   application.acc.Start >
    <cfset url.param2 = "#year(now())#/#month(now())#/#DaysInMonth(now())#">
    <cfset url.qt = "ValueDate">
</cfif>

<cfset QueryName = application.conn.RunQuery('
SELECT 
	GeneralLedgerId,GLCode,GLDescription,Debit,Credit,AccountChartType,
	CONCAT(GLCode," ",GLDescription) AS GLDesc,
	AccountChartType,ValueDate,PostingDate,Description,
	SUM(Credit) AS sCredit ,SUM(Debit) AS sDebit,
	abs(SUM(Credit) - SUM(Debit)) AS Balance
FROM vw_monthly_voucher
WHERE #url.qt# BETWEEN "#url.param1#" AND "#url.param2#"
GROUP BY GeneralLedgerId')> 

<!--- profit / loss --->
<cfquery name="qInc" dbtype="query">
SELECT SUM(sCredit) - SUM(sDebit) balance
FROM QueryName
WHERE AccountChartType = 'PI'
</cfquery>
<cfquery name="qEx" dbtype="query">
	SELECT SUM(sDebit)-SUM(sCredit)  balance 
    FROM QueryName WHERE AccountChartType = 'EX' OR AccountChartType = 'PE' 
</cfquery>
<cfset PL = val(qInc.Balance)-val(qEx.Balance)>
<!------------------------------>

<!--- query for Fixed Asset ---> 
<cfquery name="qFa" dbtype="query">
	SELECT GLDesc,sCredit,sDebit,Balance,0 faBalance,ValueDate
    FROM QueryName WHERE AccountChartType = 'FA'
    GROUP BY GLDesc,sCredit,sDebit,ValueDate,Balance  
</cfquery>
<cfquery name="qFaSum" dbtype="query">
	SELECT SUM(sDebit) faBalance
    FROM QueryName WHERE AccountChartType = 'FA' 
</cfquery> 

<cfset QueryAddRow(qFa) />
<cfset QuerySetCell(qFa,'GLDesc','<div style="font-weight:bold;" align="right">----- Total Fixed Asset -----</div><br/>') />
<cfset QuerySetCell(qFa,'ValueDate',url.param1) /> 
<cfset QuerySetCell(qFa,'Balance',qFaSum.faBalance) />

<!--- query for Current Asset ---> 
<cfset QueryName1 = application.conn.RunQuery('
SELECT 
	GeneralLedgerId,GLCode,GLDescription,Debit,Credit,AccountChartType,
	CONCAT(GLCode," ",GLDescription) AS GLDesc,
	AccountChartType,ValueDate,PostingDate,Description,
	SUM(Credit) AS sCredit ,SUM(Debit) AS sDebit,
	SUM(Debit)-SUM(Credit) AS Balance
FROM vw_monthly_voucher
WHERE #url.qt# BETWEEN "#url.param1#" AND "#url.param2#" AND AccountChartType = "CA"
GROUP BY GeneralLedgerId')> 
<cfquery name="qCA" dbtype="query">
	SELECT GLDesc,Balance AS sCredit,sDebit * 0 AS sDebit,Balance * 0 AS Balance,SUM(Balance) caBalance,ValueDate 
    FROM QueryName1
    GROUP BY GLDesc,sCredit,sDebit,ValueDate,Balance
</cfquery>
<cfquery name="qCaSum" dbtype="query">
	SELECT SUM(Balance) caBalance
    FROM QueryName1
</cfquery> 
<cfset QueryAddRow(qCa) />
<cfset QuerySetCell(qCa,'GLDesc','<div style="font-weight:bold;" align="right">----- Total Current Asset -----</div><br/>') />
<cfset QuerySetCell(qCa,'ValueDate',url.param1) /> 
<cfset QuerySetCell(qCa,'Balance',qCaSum.caBalance) />

<!--- query for Current liability ---> 
<cfset QueryName2 = application.conn.RunQuery('
SELECT 
	GeneralLedgerId,GLCode,GLDescription,Debit,Credit,AccountChartType,
	CONCAT(GLCode," ",GLDescription) AS GLDesc,
	AccountChartType,ValueDate,PostingDate,Description,
	SUM(Credit) AS sCredit ,SUM(Debit) AS sDebit,
	SUM(Credit)-SUM(Debit) AS Balance
FROM vw_monthly_voucher
WHERE #url.qt# BETWEEN "#url.param1#" AND "#url.param2#" AND AccountChartType = "CL"
GROUP BY GeneralLedgerId')> 

<cfquery name="qCl" dbtype="query">
	SELECT GLDesc,Balance AS sCredit,sDebit * 0 AS sDebit,Balance * 0 AS Balance,SUM(Balance) clBalance,ValueDate 
    FROM QueryName2
    GROUP BY GLDesc,sCredit,sDebit,ValueDate,Balance
</cfquery>
<cfquery name="qClSum" dbtype="query">
	SELECT SUM(Balance) clBalance
    FROM QueryName2
</cfquery> 
<cfset qClCount = qCl.RecordCount />
<cfset QueryAddRow(qCl,qClCount + 2) />
<cfset QuerySetCell(qCl,'GLDesc','<div style="font-weight:bold;" align="right">----- Total Liabilty -----</div><br/>',qClCount + 1) />
<cfset QuerySetCell(qCl,'GLDesc','<div style="font-weight:bold;" align="right">----- Net Asset -----</div><br/>',qClCount + 2) />
<cfset QuerySetCell(qCl,'ValueDate',url.param1,qClCount +1) /><cfset QuerySetCell(qCl,'ValueDate',url.param1,qClCount +2) />
<cfset QuerySetCell(qCl,'Balance',qClSum.clBalance,qClCount +1) />
<cfset QuerySetCell(qCl,'Balance', (val(qCaSum.caBalance) + val(qFaSum.faBalance)-val(qClSum.clBalance)),qClCount +2) />

<!--- query for Capital ---> 
<cfquery name="qCp" dbtype="query">
	SELECT GLDesc,Balance AS sCredit,sDebit * 0 AS sDebit,Balance * 0 AS Balance,SUM(Balance) cpBalance,ValueDate 
    FROM QueryName WHERE AccountChartType = 'CP' 
    GROUP BY GLDesc,sCredit,sDebit,ValueDate,Balance
</cfquery>
 
<cfset qCpCount = qCp.RecordCount />
<cfset QueryAddRow(qCp,qCpCount + 2) />
<cfset QuerySetCell(qCp,'GLDesc','<div style="font-weight:bold;" align="right">----- Current Period Profit/Loss -----</div><br/>',qCpCount + 1) />
<cfset QuerySetCell(qCp,'GLDesc','<div style="font-weight:bold;" align="right">----- Capital Employed -----</div><br/>',qCpCount + 2) />
<cfset QuerySetCell(qCp,'ValueDate',url.param1,qCpCount +1) /><cfset QuerySetCell(qCp,'ValueDate',url.param1,qCpCount +2) />
<cfset QuerySetCell(qCp,'Balance',PL,qCpCount +1) />
<cfset QuerySetCell(qCp,'Balance',PL + val(qCp.cpBalance),qCpCount +2) />
<cfquery name="QueryName" dbtype="query">
	SELECT * FROM qFa
    UNION ALL
    SELECT * FROM qCa
    UNION ALL
    SELECT * FROM qCl
    UNION ALL
    SELECT * FROM qCp
</cfquery> 
<cfimport taglib="..\..\..\core\tags\xGrid_v1000" prefix="pl">
<cfimport taglib="..\..\..\core\tags" prefix="v">
<pl:Grid	GridName="Balance Sheet"
			Solution = "#Solution#" 
			DBTable = "voucher"
            DBTableView = "vw_monthly_voucher"
			KeyField = "GLDesc"
            ReportTitle = "Balance Sheet Report"
            ReportSubTitle = "For the Period Ended: #dateformat(url.param2,'d mmm. yyyy')#"
			KeyFieldDesc = "GLDesc"
			QueryCols = "GLDesc,sDebit,sCredit,Balance"
            ColTitles = "Ledger Description,Cost,Depreciation,Net Balamce"
			QueryColTypes = "string,money,money,money"
			QueryName ="#QueryName#"  
			AllowDelete = "false"
			MaxRows = "9999"
			ActionImageName = ""
			RelatedLinkURLs="?bp=vouchers.add_dv,?bp=vouchers.view_mv,?bp=vouchers.view_tb,?bp=vouchers.view_ntb,?bp=vouchers.view_pl"
			RelatedLinks="Add New Voucher Entry, Monthly Balance View, Detail Trial Balance,Trial Balance Summary,Profit And Loss" 
            NonSearchableFields="ValueDate,PostingDate"
            DateSearchDDListValue="ValueDate,PostingDate"
            DateSearchDDList="Query By Value Date,Query By Posting Date" />
    </td>
  </tr>
  <tr>
    <td> 
<!---<cfquery name="qData" dbtype="query">
	SELECT *
    FROM GridQuery  
</cfquery> 
<cfset bal = qIncome.sCredit - qEx.sDebit  /> 
<v:View ViewQuery="#qData#"
    	ViewTitle = "Opening Balance"
        LabelList = "Total Income,Total Expenses,Net Profit/Loss"
        ColList="#qIncome.sCredit#,#qEx.sDebit#,#bal#"
        ColFormatList = "money,money,money"
        ViewAlign = "right"  />  ---> 
    </td>
  </tr>
</table>
  

