<!---//--------------------------------------------------------------------
	Name:		Chart.cfm
	Author:		Arowolo Michael .A.
	Created:	15/08/2007
	Updated:	02/09/2007
	Copyright:	(c) 2008	
	Purpose:	create a chart
	Code-Type:  Tag
	
	use: [Parameter-Name][data-type][requred][required-Parameter-Name][default-value]	-	[description][example]
	Title[string][yes]		-	the tile of the Chart
	
	Dependencies: [Dependency-Name][Type]				-	[Description] 
---------------------------------------------------------------------//--->

<CFIF ThisTag.ExecutionMode EQ "Start">
	<CFPARAM name="Attributes.Title" type="string" default="">
	<CFPARAM name="Attributes.Format" type="string" default="flash">
	<CFPARAM name="Attributes.XAxisTitle" type="string" default="">
	<CFPARAM name="Attributes.YAxisTitle" type="string" default=""> 
	<CFPARAM name="Attributes.Show3D" default="NO" type="boolean">
	<CFPARAM name="Attributes.BackgroundColor" default="white" type="string">
	<CFPARAM name="Attributes.ShowLegend" type="boolean" default="true" >
	<CFPARAM name="Attributes.ShowBorder" type="boolean" default="false" > 
	<CFPARAM name="Attributes.ChartQuery" type="array" > 
	<CFPARAM name="Attributes.ChartSeriesType" type="string" > 
	<CFPARAM name="Attributes.ChartDataName" type="string" >
	<CFPARAM name="Attributes.ChartDataValue" type="string" >
	<CFPARAM name="Attributes.ChartDataFormat" type="string" default="">
	<CFPARAM name="Attributes.Height" type="integer" default="290" min="10" > 
	<CFPARAM name="Attributes.Width" type="integer" default="300" min="10"> 
	<CFPARAM name="Attributes.LabelMask" type="string" default="_,___.__"> 
	<CFPARAM name="Attributes.LabelFormat" type="string" default="number"> 
	<CFPARAM name="Attributes.URL" type="string" default=""> 
	<CFPARAM name="Attributes.SeriesLabelList" type="string" default="">
	<CFPARAM name="Attributes.MarkerStyle" type="string" default="triangle">
	<CFPARAM name="Attributes.PaintStyle" type="string" default="plain">
	<CFCHART format="#Attributes.Format#" show3d="#Attributes.Show3D#" 
			backgroundcolor="#Attributes.BackgroundColor#"
			xaxistitle="#Attributes.XAxisTitle#" 
			yaxistitle="#Attributes.YAxisTitle#" sortxaxis="yes"
	        gridlines=5 labelformat="#Attributes.LabelFormat#" labelmask="N #Attributes.LabelMask#"
			showxgridlines="no" title="#Attributes.Title#" url="#Attributes.URL#"
			showygridlines="yes"  chartheight="#Attributes.Height#" chartwidth="#Attributes.Width#"
			showborder="#Attributes.ShowBorder#" showlegend="#Attributes.ShowLegend#" 
	>  
	<CFSET ChartQueryLn = ArrayLen(Attributes.ChartQuery)>
	<CFSET lendFormat = len(Attributes.ChartDataFormat)>
	<CFIF left(Attributes.ChartDataFormat,4) EQ 'date'>
		<CFSET dformat = Right(Attributes.ChartDataFormat,lenDformat-5)>
	</CFIF>
	<CFLOOP from="1" to="#ChartQueryLn#" index="iPos"> 
			<CFSET gType = ListGetAt(Attributes.ChartSeriesType,iPos,',')>
			<CFSET dName = ListGetAt(Attributes.ChartDataName,iPos,',')>
			<CFSET dValue = ListGetAt(Attributes.ChartDataValue,iPos,',') >
			<CFSET sLabel = "">
			<CFIF len(Attributes.SeriesLabelList) neq 0>
				<CFSET sLabel = ListGetAt(Attributes.SeriesLabelList,iPos,',') >
			</CFIF>
			<CFSET qData = Attributes.ChartQuery[iPos]>
			<CFIF qData.RecordCount eq 0><CFEXIT method="exittag"></CFIF>
			<CFCHARTSERIES type="#gType#" paintstyle="#Attributes.PaintStyle#" markerstyle="#Attributes.MarkerStyle#" serieslabel="#sLabel#" seriescolor="#generateColors()#" colorlist="#generateColors(qData.RecordCount)#" >
				<CFLOOP query="qData">
					<CFSET dname_ = Evaluate(dname)>
					<CFIF left(Attributes.ChartDataFormat,4) EQ "date">
						<CFSET dname_ = dateformat(dname_,dformat)>
					</CFIF>
					<CFCHARTDATA item="#dname_#" value="#Evaluate(dvalue)#"    />
				</CFLOOP>
			</CFCHARTSERIES>
		</CFLOOP>
	</CFCHART>	 
<!--- end tag --->
<CFELSE>  
</CFIF>
<!--- tag functions --->
<CFFUNCTION name="generateColors" access="private" returntype="string">
	<CFARGUMENT name="Amount" default="1" > 
	
	<CFSET temp = "">
	<CFSET ColorCode = "A,B,C,D,E,F,0,1,2,3,4,5,6,7,8,9">
	<CFLOOP from="1" to="#Amount#" index="i">
		<CFLOOP from="1" to="6" index="j">
			<CFSET temp = temp & ListGetAt(ColorCode,randRange(1,16),',')>
		</CFLOOP>
		<CFSET temp = ListAppend(temp,"")>
	</CFLOOP>
	<CFSET temp=left(temp,len(temp)-1)>
	<CFRETURN temp>
</CFFUNCTION>
