<!---//--------------------------------------------------------------------
	Name:		com_add.cfm
	Author:		Arowolo Michael .A.
	Created:	07/06/2007
	Updated:	23/03/2008
	Copyright:	(c) 2008	
	Purpose:	To dynamically create a form and add a Record to the database
	Code-Type:  Tag
	use: [Parameter-Name][data-type][requred]
		[required-Parameter-Name][default-value]		-	[description][example]
	TableName[string][yes]								-	the name of the table in the db
	FormName[string][yes]								-	the name of the form[Customer]
	FormAlign[string][no][center]						-	the alignment of the form[left]
	FormWidth[string][no][400]							-	the width for the form/table[45%,500]
	FormTitle[string][yes]								-	the title on the form/table
	FormLabels[string][yes]								-	the label on the field of the form[Surname, Other Names, Address]
	FormNames[string][yes]								-	the progamatical & field name of each control on  the form[Surname, OtherNames, Address]
	FormType[string][yes][add]							-	the type of form(add/edit)[edit]
	FormInputTypes[string][yes]							-	the type of input[drop down,text,text]
	WhereClause[string][if FormType=Edit]				-	the SQL where clause[WHERE CustomerId = 3011]
	IsFormInputRequired[string][yes]					-	make input field required in list form[yes,yes,no]
	HiddenInputs[string][no]							-	hidden values[datecreated,timemodified]
	HiddenInputValues[string][no][HiddenInputs]			-	the value of the hidden input[12/4/2007,4:09PM]
	RedirectURL[string][yes]							-	location to go to after insertion[?bp=...]
	DropDownQuerys[Query][no]							-	Name of Query for drop down list, in form of list
	DropDownQueryValues[string][DropDownQuerys]			-	the value of the Query (list)
	SelectRecordLinks[string][no]						-	the link that contains the list of where to pick input from
	RunToEnd[boolean][no]								-	to allow you add custome code add the end of the tage
	DropDownQueryTexts[string][no]						-	the text for the dropdown list (list)
	BreadCrumbLinks[string][no]							-	links name displayed on top of the page, that allow users to navigate to other pages
	BreadCrumbLinkUrls[string][no][BreadCrumbLinks]		-	the url of the link
	BreadCrumbIcons[string][no]							-	imagename icon of the link[pic1.gif,edit.gif]
	GroupFieldsInto[string][no]							-	use this to allow grouping of fields
	GroupFieldTitleList[string][no]	[GroupFieldsInto]	-	the title for each group of fields[Name,Address]
	LeaveValueAfterInsertList[boolean][no]				-	restore back a value to its input button(list) 
	PostBackVariableName[variableName][no][RunToEnd]	-	the variable name to check if the form has been posted back

	Dependencies: [Dependency-Name][Type]				-	[Description]
	application.conn.RunQuery(SQL statement)[function]	-	Execuit SQL Statements
	server.cfm[include-template][functions]				-	server related functions
	query.cfm[include-template][functions]				-	query related functions 
	core:LogEvent[....][tag]							-	Logs add.edit event raised
---------------------------------------------------------------------//--->
<!--- Opening tag executed --->
<link href="../../skin/<cfoutput>#request.skinname#</cfoutput>/css/style.css" rel="stylesheet" type="text/css" />
<link href="../../skin/officemod/css/style.css" rel="stylesheet" type="text/css" />
<cfif ThisTag.ExecutionMode EQ "Start">
	<cfparam name="Attributes.TableName" type="string" >
	<cfparam name="Attributes.FormAlign" default="Left" >
	<cfparam name="Attributes.FormName" default="" >
	<cfparam name="Attributes.FormWidth" default="460" >
	<cfparam name="Attributes.FormTitle" type="string" >
	<cfparam name="Attributes.FormLabels" type="string" >
	<cfparam name="Attributes.LabelPrefix" type="string" default="" >
	<cfparam name="Attributes.LabelSurfix" type="string" default=" :" >
	<cfparam name="Attributes.FormNames" default="" type="string" >
	<cfparam name="Attributes.FormType" default="Add" type="string" >
    <cfparam name="Attributes.DefaultValue" default="" type="string" >
    <cfparam name="Attributes.OnChangeEvent" default="" type="string" >
	<cfparam name="Attributes.FormInputTypes" default="" >
    <cfparam name="Attributes.Icon" default="" >
	<cfif Attributes.FormType eq "Edit">
		<cfparam name="Attributes.WhereClause" type="string">
	</cfif>
	<cfparam name="Attributes.IsFormInputRequired" >
	<cfparam name="Attributes.HiddenInputs" default="" type="string" >
	<cfif Attributes.HiddenInputs neq "">
		<cfparam name="Attributes.HiddenInputValues" type="string" >
	</cfif>
	<cfparam name="Attributes.RedirectURL"  >
	<cfparam name="Attributes.DropDownQuerys" default="" type="string" >
	<cfif Attributes.DropDownQuerys neq "">
		<cfparam name="Attributes.DropDownQueryValues" type="string" >
	</cfif>
	<cfparam name="Attributes.DropDownQueryTexts" type="string" default="" >
	<cfparam name="Attributes.SelectRecordLinks" default="">
	<cfparam name="Attributes.RunToEnd" default="false">
	<cfparam name="Attributes.BreadCrumbLinks" default="">
	<cfif Attributes.BreadCrumbLinks neq "">
		<cfparam name="Attributes.BreadCrumbLinkUrls" type="string">
	</cfif>
	<cfparam name="Attributes.BreadCrumbIcons" type="string" default="">
	<cfparam name="Attributes.GroupFieldsInto" default="" type="string">
	<cfparam name="Attributes.GroupFieldTitleList" type="string" default="">
	<cfparam name="Attributes.LeaveValueAfterInsertList" default="">
	<cfparam name="Attributes.Solution" default="OfficeMod.">
	<cfparam name="Attributes.PostBackVariableName" type="VariableName" default="IsPostBack">
    <cfparam name="Attributes.TransactionIdVariableName" type="VariableName" default="TransactionId">
    <cfparam name="Attributes.PostRecord" type="boolean" default="true"><!--- post / update this record --->
    <cfparam name="Attributes.DisableCancel" type="boolean" default="false">
    <cfparam name="Attributes.SubmitTextValue" type="string" default="Update #Attributes.FormName#">
    
	<cfinclude template="../udf/server.cfm">
	<cfinclude template="../udf/query.cfm">
	<cfimport taglib="\" prefix="core">
	<!--- error trap --->
	<cfif listLen(Attributes.FormLabels) neq listlen(Attributes.FormNames)>
		<cfthrow errorcode="1" message="FormLabels Parameter must have the same List count with FormNames Parameter"
		 detail="FormLabels - [#Attributes.FormLabels#]<br/>
		 FormLabels Count - [#listlen(Attributes.FormLabels)#]<br/>
		 FormNames - [#Attributes.FormNames#]<br/>
		 FormNames Count - [#listlen(Attributes.FormNames)#]<br/>" >
	</cfif>
<cfinclude template="../udf/udf_form.cfm" />
<!---<style>
	.autosuggest div 	{ float:none !important; display:none; }
	.autosuggest div input	{ float:none !important; display:block; }
</style>--->
<script type="text/javascript" language="javascript">
	function clear(item_)	{
		document.getElementById(item_).value="";
		document.getElementById(item_ + "_").value="";
	}
</script>

	<!--- hidden form input name --->
    <cfset PostBackName = Replace(Attributes.FormName,' ','','all') & "_PostBack">
	<cfif structkeyexists(form,PostBackName)>
		<!---// Add Record //--->
        <cfif Attributes.PostRecord>
			<cfset Caller[Attributes.PostBackVariableName] = "true">
			<cfif Attributes.FormType eq "Add">  
                <cfset sql="INSERT INTO #Attributes.TableName#	( ">
                <cfset sql_field = ""/>
                <!---<cfset sql=sql & "#Attributes.FormNames#">--->
                <cfloop list="#Attributes.FormNames#" delimiters="," index="fn">
                    <!---<cfif structkeyexists(form,fn)>--->
                        <cfset sql_field = ListAppend(sql_field,fn) />
                    <!---</cfif>--->
                </cfloop> 
                <cfset sql = sql & sql_field />
                <cfif Attributes.HiddenInputs neq "">
                    <cfset sql = sql & ",#Attributes.HiddenInputs#" />
                </cfif>
                <cfset sql =sql & " ) VALUES ( ">
                <cfset value_="">
                <cfset value2="">
                <cfset iPos=0>
                <cfloop list="#Attributes.FormNames#" delimiters="," index="fn">
                    <cfset iPos = iPos + 1>
                    <cfset fn=trim(fn)>
                    <cfset fType=trim(listgetat(Attributes.FormInputTypes,iPos,','))> 
                    <cfif structkeyexists(form,fn)>
                        <cfset nfv = Form[fn] />
                        <cfswitch expression="#fType#">
                            <cfcase value="file">
                            <cfset fileDir = "#ExpandPath('docs\images\')#" />
                            
                            <cfset filen="">
                            <cfif nfv neq ""> 
                                <cfif NOT(DirectoryExists(fileDir))>
                                    <cfdirectory action="create" directory="#fileDir#" />
                                </cfif> 
                                <cffile action="Upload"
                                    filefield="#fn#"
                                    destination="#fileDir#"
                                    nameconflict="MakeUnique">
                                <cfset filen=cffile.ServerFile> 
                            </cfif>
                            <!--- save file to db --->
                            <cfset value_ = ListAppend(value_,'"#filen#"',",")>
                            </cfcase>
                            <cfcase value="float,integer" delimiters=",">
                                <cfif nfv eq "">
                                    <cfset nfv="0">
                                </cfif>
                                <cfset value_ = ListAppend(value_,"#nfv#",",")>
                            </cfcase>
                            <cfcase value="money" >
                                <cfif nfv eq "">
                                    <cfset nfv="0">
                                </cfif>
                                <cfset value_ = ListAppend(value_,"#Replace(nfv,',','','all')#",",")>
                            </cfcase>
                            <cfcase value="date">
                                <cfif nfv eq "">
                                    <cfset nfv= "NULL" />
                                    <cfset value_ = ListAppend(value_,nfv,",") />
                                <cfelse>
                                    <cfset value_ = ListAppend(value_,'"#nfv#"',",") />
                                </cfif>
                            </cfcase>
                            <cfcase value="autosuggest,autosugest,autolist" delimiters=",">
                            	<!--- for autosuggest, user [list]-[id to post] --->
                                <cfset nfv = trim(listlast(nfv,'-'))>
                                <cfset nfv = trim(listlast(nfv,'|'))>
                                
                                <cfif nfv eq ""><cfset nfv = 0 ></cfif>
                                <cfset value_ = ListAppend(value_,"#nfv#",",")>
                                <cfset form[fn] = nfv >
                            </cfcase>
                            <cfcase value="textarea">
                           		<!--- update textarea case --->
								<cfset b = CreateObject('component','com.adexfe.util.bString').init()>
                                <cfset nfv = b.Capitalize2(nfv)> 
                                <cfset value_ = ListAppend(value_,'"#nfv#"',",")>
                            </cfcase>                            
                            <cfdefaultcase>
                                <cfset value_ = ListAppend(value_,'"#nfv#"',",")>
                            </cfdefaultcase>
                        </cfswitch>
                    </cfif>
                </cfloop>
                <cfset sql=sql & value_ >
                <cfif Attributes.HiddenInputs neq "">
                    <cfloop  list="#Attributes.HiddenInputValues#" index="hv">
                        <cfset sql = sql & ',"#hv#"'>
                    </cfloop>
                </cfif>
                <cfset sql = sql & ")">
                <cftransaction >
                	<cfquery result="result" datasource="#application.dsn#">
                        #sql#
                    </cfquery>  
                    <cfset Caller[Attributes.TransactionIdVariableName] = result.GENERATED_KEY>
                </cftransaction>
                <!--- log added record to system ---->
                <!---<cfthread name="gen_">--->
                	<cfset desc = "The Record #Replace(value_,'"','|','all')# was add to #Attributes.FormName#">
                	<core:LogEvent 	SolutionName = "#Attributes.solution#" 
                                	LogTitle = "#Attributes.FormName#" LogType = "add" 
                                	LogDescription = "#desc#" />
                <!---</cfthread>--->
                <!--- start Update --->
                
                <cfelseif Attributes.FormType eq "Edit">
                <cfset Caller[Attributes.PostBackVariableName] = "true">
                <cfset sql="UPDATE #Attributes.TableName# SET ">
                <cfset iPos=0>
                <cfset setList="" >
                <cfloop list="#Attributes.FormNames#" index="fn">
                    <cfset ipos=ipos+1 >
                    <cfset fn=trim(fn) >
                    <cfset fType=trim(listgetat(Attributes.FormInputTypes,iPos,',')) > 
                    <cfif StructKeyExists(form,fn)>
                        <cfset nfv = Form[fn] >
                        <cfswitch expression="#fType#">
                            <cfcase value="file">
                                 <cfset fileDir = "#ExpandPath('docs\images\')#" /> 
                                 <cfif nfv neq "">
                                 <cfthread name="#createuuid()#">
                                    <!--- delete the old file if on server---> 
                                    <cfset qData = application.conn.RunQuery('SELECT #fn# FROM #Attributes.TableName# #Attributes.WhereClause#') />
                                    <cfset rs = "qData.#fn#" /> 
                                        <cfset fi_del="#fileDir##Evaluate(rs)#">
                                        <cfif FileExists(fi_del)>
                                            <cffile action="DELETE" file="#fi_del#">
                                        </cfif> 
                                    <!--- uploading new file to the server ---> 
                                        <cfif NOT(DirectoryExists(fileDir))>
                                            <cfdirectory action="create" directory="#fileDir#" />
                                        </cfif>
                                  </cfthread>
                                    <cffile action="Upload" filefield="#fn#"
                                        destination="#fileDir#"
                                        nameconflict="MakeUnique">
                                    <!--- save file to db --->
                                    <cfset setList=ListAppend(setList,'#fn# = "#cffile.ServerFile#"',",")>
                                </cfif>
                            </cfcase>
                            <cfcase value="float,integer" delimiters=",">
                                <cfif nfv eq "">
                                    <cfset nfv="0" />
                                </cfif>
                                <cfset setList=ListAppend(setList,'#fn# = #nfv#',",")>
                            </cfcase>
                            <cfcase value="money">
                                <cfif nfv eq "">
                                    <cfset nfv="0" />
                                </cfif>
                                <cfset fmoney = Replace(nfv,",","","all")>
                                <cfset setList=ListAppend(setList,'#fn# = #fmoney#',",")>
                            </cfcase>
                            <cfcase value="date" >
                                <cfif nfv eq "">
                                <!---- skip date insert --->
                                <cfelse>
                                    <!---<cfset nfv="" />--->
                                    <cfset setList=ListAppend(setList,'#fn# ="#nfv#"',",")>
                                </cfif>
                            </cfcase>
                             <cfcase value="autosuggest,autosugest,autolist" delimiters=",">
                            	<!--- for autosuggest, user [list]-[id to post] --->
                                <cfset nfv = trim(listlast(nfv,'-'))>
                                <cfset nfv = trim(listlast(nfv,'|'))>
                                
                                <cfif nfv eq ""><cfset dbId = 0 ></cfif>
                                <!---<cfset value_ = ListAppend(value_,"#nfv#",",")>
                                <cfset form[fn] = nfv >--->
                                <cfset setList=ListAppend(setList,'#fn# = #nfv#',",")>
                            </cfcase>
                            <cfcase value="textarea">
                           		<!--- update textarea case --->
								<cfset b = CreateObject('component','com.adexfe.util.bString').init()>
                                <cfset nfv = b.Capitalize2(nfv)>  
                                <cfset setList=ListAppend(setList,'#fn# = "#nfv#"',",")>
                            </cfcase>
                            <cfdefaultcase>
                                <cfset setList=ListAppend(setList,'#fn# = "#nfv#"',",")>
                            </cfdefaultcase>
                        </cfswitch>
                     </cfif>
                </cfloop>
                <cfif Attributes.HiddenInputs neq "">
                    <cfset ipos=0>
                    <cfloop  list="#Attributes.HiddenInputValues#" index="hv">
                        <cfset ipos = ipos + 1 />
                        <cfset fn=listgetat(Attributes.HiddenInputs,ipos,',')>
                        <cfset setList=ListAppend(setList,'#fn# = "#hv#"',",")>
                    </cfloop>
                </cfif>
                <cfset sql=sql & setList & " " & Attributes.WhereClause />
                <!---<CFOUTPUT>#sql#</CFOUTPUT>--->
                <cfset application.conn.RunQuery(sql)>
                <!--- log added record to system ---->
                <!---<cfthread name="#createuuid()#">--->
                <cfset drec = replace(setList,'"',"","all")>
                <core:LogEvent 	SolutionName = "#Attributes.solution#" 
                    LogTitle = "#Attributes.FormName#" LogType = "edit"  
                    LogDescription = "The Record #drec# was updated in #Attributes.FormName#" />
                 <!---</cfthread>--->
                <cfset value_=setList>
                <!---///--->
                <cfif Not(Attributes.RunToEnd)>
                    <cflocation addtoken="no" url="#Attributes.RedirectURL#&#BuildQueryString('pn,sortby,id,rp,sid,grp,id2,order,id3')#&pk=#id#">
                </cfif>
            <cfelse> <!--- none --->
                <cfif Not(Attributes.RunToEnd)>
                    <cflocation addtoken="no" url="#Attributes.RedirectURL#&#BuildQueryString('pn,sortby,id,rp,sid,grp,id2,order,id3')#&pk=#id#">
                </cfif>
            </cfif>
        </cfif>
	</cfif>
	<!---////--->
	<cfoutput>
		<cfset itemPos = 0>
		<cfif structkeyexists(form,PostBackName)>
			<cfif isdefined("value_")>
			<div class="Tip">
				<div class="Success">
					<h3>#Attributes.FormName# Saved</h3>
					The Record <strong>#trim(value_)#</strong> was saved successfuly</div>
			</div>
			<p/>
			</cfif>
		</cfif>
		<!--- get the query if form is edit--->
		<cfif Attributes.FormType eq "Edit">
			<cfset QueryName = application.conn.RunQuery('SELECT #Attributes.FormNames# 
			FROM #Attributes.TableName# #Attributes.WhereClause#')>
		</cfif>
		<cfform name="#Attributes.TableName#" id="#Attributes.TableName#" enctype="multipart/form-data" method="post" action="">
		<table width="#Attributes.FormWidth#" align="#Attributes.FormAlign#" border="0" cellspacing="0" cellpadding="0">
			<cfif listlen(Attributes.BreadCrumbLinks) gt 0>
				<tr>
					<td   class="Link"><cfset iPos =0>
						<ul>
							<cfloop list="#Attributes.BreadCrumbLinks#" index="getLink">
								<cfset iPos=iPos+1>
								<li>
									<cfif ListLen(Attributes.BreadCrumbLinkURLs) gte iPos>
										<cfset getLinkURL=Listgetat(Attributes.BreadCrumbLinkURLs,iPos)>
										<a href="#getLinkURL#">
										<cfif ListLen(Attributes.BreadCrumbIcons) gte iPos>
											<img src="#SkinRoot()##request.skinname#/images/#listgetat(Attributes.BreadCrumbIcons,iPos)#" width="8" hspace="2" border="0" align="absmiddle" />
										</cfif>
										#getLink#</a> &nbsp;&nbsp;|
										<cfelse>
										<cfif ListLen(Attributes.BreadCrumbIcons) gte iPos>
											<img src="#SkinRoot()##request.skinname#/images/#listgetat(Attributes.BreadCrumbIcons,iPos)#" width="8" hspace="2" border="0" align="absmiddle" />
										</cfif>
										#getLink#
									</cfif>
								</li>
							</cfloop>
						</ul></td>
				</tr>
			</cfif>
			<tr>
				<td nowrap="nowrap"><div class="TableFormHead"><cfif Len(Attributes.Icon)><img src="#SkinRoot()##request.skinname#/images/#Attributes.icon#" align="absmiddle" hspace="1" /></cfif>#Attributes.FormTitle#</div>
					<div class="FormBody">
						<cfloop list="#Attributes.FormLabels#" delimiters="," index="label" >
                        	<cfset label = trim(label)>
							<cfset itemPos=itemPos+1>
							<cfset getRestoreValue="no">
							<cfset getFG="">
							<cfset getFT="">
                            <cfset getDefaultValue ="" />
                            <cfset getOnChangeEvt = "" />
							<cfif Listlen(Attributes.GroupFieldsInto) gte itemPos>
								<cfset getFG=trim(listgetat(Attributes.GroupFieldsInto,itemPos))>
							</cfif>
							<cfif Listlen(Attributes.GroupFieldTitleList) gte itemPos>
								<cfset getFT=trim(listgetat(Attributes.GroupFieldTitleList,itemPos))>
							</cfif>
							<cfif Listlen(Attributes.LeaveValueAfterInsertList) gte itemPos>
								<cfset getRestoreValue=trim(listgetat(Attributes.LeaveValueAfterInsertList,itemPos))>
							</cfif>
							<cfif Listlen(Attributes.DefaultValue,'~') gte itemPos>
								<cfset getDefaultValue=trim(listgetat(Attributes.DefaultValue,itemPos,'~'))>
                                <cfif getDefaultValue eq "x"><cfset getDefaultValue="" /></cfif>
							</cfif>
							<cfif Listlen(Attributes.OnChangeEvent) gte itemPos>
								<cfset getOnChangeEvt=trim(listgetat(Attributes.OnChangeEvent,itemPos))>
							</cfif>
							<cfset fName = trim(ListGetAt(Attributes.FormNames,itemPos,','))>
							 <cfset fInputType = trim(ListGetAt(Attributes.FormInputTypes,itemPos,','))> 
                             
                            
                            <!------->
							<cfset fRequired = trim(ListGetAt(Attributes.IsFormInputRequired,itemPos,','))>
							<cfset fErrMsg = "#label# is required please">
							<cfset reqImage ='<img src="#skinroot('')##request.skinname#/images/#fRequired#.gif" align="absmiddle" border="0" />'>
							<!--- start field group --->
							<cfif getFG eq "<x">
								<fieldset>
								<legend>#getFT#</legend>
							</cfif>
							<!---/ start form body /---->
                            <span id="formItem_#fName#"><label><span>#reqImage##Attributes.LabelPrefix##label##Attributes.LabelSurfix#</span>
							<cfif getRestoreValue>
								<input type="checkbox" class="checkBox" checked="#structkeyexists(form,'_#fName#_')#" name="_#fName#_" />
							</cfif>	
							<cfset restorV = getDefaultValue />
                            <!--- restore value --->
                            <cfif getRestoreValue and StructKeyExists(Form,fName)>
                            	<cfset restorV = Form[fName] />
                            </cfif> 
							<!--- --->
							<cfif Attributes.FormType eq "edit">
								<cfset restorV = QueryName[fName]>
							</cfif> 
                              
							<cfswitch expression="#fInputType#">
								<cfcase value="date">
								<cfinput type="text" name="#fName#" value="#dateformat(restorV,'yyyy/m/d')#"  id="#fName#" message="#fErrMsg#" onblur="javascript:this.className='TextBox_LostFocus';" required="#fRequired#" onfocus="javascript:this.className='TextBox_GetFocus';return showCalendar('#fName#', '%Y/%m/%d');" validate="date" /><img onclick="return showCalendar('#fName#', '%Y/%m/%d');" src="#skinroot('')##request.skinname#/images/date.gif" align="absmiddle"  border="0" />
								</cfcase>
								<cfcase value="file">
								<input onchange="switchImage('#fName#_', this.value);" value="#restorV#"  onblur="javascript:this.className='TextBox_LostFocus';"  onfocus="javascript:this.className='TextBox_GetFocus';" id="#fName#" name="#fName#" type="file" />
								<br/><img width="90px" src="docs/images/#restorV#"  name="#fName#_" id="#fName#_" />
								</cfcase>
								<cfcase value="textarea">
								<cftextarea required="#fRequired#" name="#fName#" onblur="javascript:this.className='TextBox_LostFocus';" onfocus="javascript:this.className='TextBox_GetFocus';" message="#fErrMsg#">#restorV#</cftextarea>
								</cfcase>

								<cfcase value="html,editor,htm" delimiters=",">
								<cftextarea required="#fRequired#" richtext="true" toolbar="Basic" width="300" height="120" name="#fName#" onblur="javascript:this.className='TextBox_LostFocus';" onfocus="javascript:this.className='TextBox_GetFocus';" message="#fErrMsg#">#restorV#</cftextarea>
								</cfcase>
                                
								<cfcase value="disabled,readonly" delimiters=",">
								<input readonly="readonly" name="#fName#" style="background-color:##CCCCCC" id="#fName#" value="#restorV#" />
								</cfcase>
								<cfcase value="float,integer" delimiters=",">
								<cfinput name="#fName#" message="Please make sure #label# is in it's correct format(#fInputType#)" validate="#fInputType#" onblur="javascript:this.className='TextBox_LostFocus';" onfocus="javascript:this.className='TextBox_GetFocus';" required="#fRequired#" type="text" value="#restorV#">
								</cfcase> 
								<cfcase value="money">
								<cfinput name="#fName#" message="Please make sure #label# is in it's correct format(#fInputType#)" onblur="javascript:this.className='TextBox_LostFocus';" onfocus="javascript:this.className='TextBox_GetFocus';" required="#fRequired#" type="text" value="#restorV#" onkeyup="ValidateAndFormatNumber(this)">
								</cfcase>
								<cfcase value="select" > 
								<cfset getDDQuery = trim(listgetat(Attributes.DropDownQuerys,itempos,'-'))>
								<cfif trim(left(getDDQuery,6)) eq 'SELECT'>
									<cfset qselect = application.conn.RunQuery(getDDQuery)> 
									<cfselect name="#fname#"  required="#fRequired#" query="qselect" queryPosition="below" multiple="no" value="#fname#" display="#listgetat(Attributes.DropDownQueryValues,itempos,',')#" selected="#restorV#" onBlur="javascript:this.className='TextBox_LostFocus';" onFocus="javascript:this.className='TextBox_GetFocus';" message="#fErrMsg#">
                                		<option value="0">-- Select #label# --</option>
                                	</cfselect>
								<cfelse><!--- LIST ---> 
									<select name="#fname#" onchange="#getOnChangeEvt#"  > 
									<cfset sortType = "TextNoCase">
									<cfif ReFind('[0-9]+',getDDQuery)><cfset sortType = "Numeric"></cfif>
									<cfset getDDQuery = ListSort(getDDQuery,sortType)>
                                    <option value="">-- Select #label# --</option>
									<cfloop list="#getDDQuery#" index="lst">	
										<option <CFIF lst eq restorV> selected="selected" </cfif> value="#lst#" >#lst#</option>
									</cfloop>
								</select>
								</cfif> 
								</cfcase>
								<cfcase value="list" >								
								<cfset Qdd = listgetat(Attributes.DropDownQuerys,itempos,'-') />
                                <select name="#fname#" multiple="multiple" size="10" onblur="javascript:this.className='TextBox_LostFocus';" onfocus="javascript:this.className='TextBox_GetFocus';">
                                <cfif IsQuery(Qdd)>
									<cfset qselect = application.conn.RunQuery(Qdd)>
                                <cfelse>
                                <!--- not a query. then convert to query --->
                                	<cfset qselect = ListToQuery('#fname#',Qdd) />
                                </cfif>
									<cfloop query="qselect" >
										<cfset item=evaluate(listgetat(Attributes.DropDownQueryValues,itempos,','))>
										<cfset item2=item>
										<cfif listlen(Attributes.DropDownQueryTexts) gte itempos>
											<cfset item2=evaluate(listgetat(Attributes.DropDownQueryTexts,itempos,','))>
										</cfif>  
										<option <CFIF ListFindNoCase(restorV,item2) > selected="selected" </cfif> value="#item2#">#item#</option> 
									</cfloop>                                      
								</select>  
								</cfcase>
								<cfcase value="openrecord">
								<cfset selectRecLink=Listgetat(Attributes.SelectRecordLinks,itemPos)>
								<cfinput id="#fName#_" name="#fName#_" value="#getDefaultValue#" readonly="readonly" message="#fErrMsg#" onblur="javascript:this.className='TextBox_LostFocus';" onfocus="javascript:this.className='TextBox_GetFocus';" required="#fRequired#" type="text"><a href="javascript:openPopup2('#selectRecLink#');"><img src="#skinroot('')##request.skinname#/images/select.gif" border="0" align="absmiddle" alt="Select #label#" /></a>&nbsp;<a href="javascript:clear('#fName#');"><img src="#skinroot('')##request.skinname#/images/clear.gif" border="0" align="absmiddle" alt="Clear #label#" /></a>
                                <!--- hide he real value and post it --->
                                <input type="hidden" id="#fName#" name="#fName#" value="#restorV#" />
								</cfcase>
								<cfcase value="plaintext">
								<cfinput name="#fName#" value="#restorV#" message="#fErrMsg#" onblur="javascript:this.className='TextBox_LostFocus';" onfocus="javascript:this.className='TextBox_GetFocus';" required="#fRequired#" type="text">
								</cfcase>
								<cfcase value="mobile">
								<cfinput name="#fName#" mask="+999(999) 999 9999" value="#restorV#" message="#fErrMsg#" required="#fRequired#" type="text">
								</cfcase>
								<cfcase value="phone">
								<cfinput name="#fName#" mask="+999(999) 999 9999 9999" value="#restorV#" message="#fErrMsg#" required="#fRequired#" type="text">
								</cfcase>
                                
								<cfcase value="password">
								<cfinput name="#fName#" value="#restorV#" message="#fErrMsg#" onblur="javascript:this.className='TextBox_LostFocus';" onfocus="javascript:this.className='TextBox_GetFocus';" required="#fRequired#" type="password">
								</cfcase>
								<cfcase value="email">
								<cfinput onchange="javascript:this.value=stringToLowercase(this.value);" name="#fName#" message="#fErrMsg#" onblur="javascript:this.className='TextBox_LostFocus';" validate="email" onfocus="javascript:this.className='TextBox_GetFocus';" required="#fRequired#"  value="#restorV#" type="text">
								</cfcase>
								<cfcase value="url">
								<cfinput onchange="javascript:this.value=stringToLowercase(this.value);" name="#fName#" message="#fErrMsg#" onblur="javascript:this.className='TextBox_LostFocus';" validate="url" onfocus="javascript:this.className='TextBox_GetFocus';" required="#fRequired#" value="#restorV#" type="text">
								</cfcase>
                               
								<cfcase value="radio,option,radiooption,radio_option" delimiters=","><br />
                                <cfset delf = restorV> 
                                <cfset restorV = getDefaultValue>					
                                <cfloop list="#restorV#" index="rdList" delimiters="|">
                                <cfset chked = "no">
                                <cfif delf eq rdList > <cfset chked = "yes"></cfif> 
                                <label id="innerOption_#fName#" style="padding-left:180px"><cfinput type="radio" name="#fName#" value="#rdList#" checked="#chked#" message="#fName#: Please Select Any Option from #restorV#" required="#fRequired#" />#rdList#                        
                                </label>
                                </cfloop> 
								</cfcase>
                               
								<cfcase value="autosuggest,autosugest,autolist" delimiters=","><table border="0"><tr><td>
                                <!--- format the autosuggest output --->
                                <cfset restorV = getDefaultValue>
                                	<cfset defaulttxt = listgetat(restorV,1,'$')>
                                	<!---<cfset autotext = ListDeleteAt(restorV,1,'|')>--->
                                    <cfset autotext = ListChangeDelims(restorV,',','$')>
                                    <cfif defaulttxt eq '-'><cfset defaulttxt=""></cfif>
								<cfinput name="#fName#" maxResultsDisplayed="30" size="35" message="#fErrMsg#" onblur="javascript:this.className='TextBox_LostFocus';"  onfocus="javascript:this.className='TextBox_GetFocus';" required="#fRequired#" value="#defaulttxt#" autosuggest="#autotext#" type="text"></td></tr></table>
								</cfcase>
								<cfcase value="normal,string,text" delimiters=",">
								<cfinput onchange="javascript:this.value=capitalizeWords(this.value);" name="#fName#" message="#fErrMsg#" onblur="javascript:this.className='TextBox_LostFocus';"  onfocus="javascript:this.className='TextBox_GetFocus';" required="#fRequired#" value="#restorV#" type="text">
								</cfcase>
                            </cfswitch>
                            <!--- custom masking ---->
                            <cfset maskvalue = "">
							<cfif left(fInputType,5) eq "mask:">
                            	<cfset maskvalue = mid(finputType,6,len(fInputType))>
                                <cfinput name="#fName#" mask="#maskvalue#" message="#fErrMsg#"    required="#fRequired#" value="#restorV#" type="text">
                            </cfif> 
                            
							</label></span>
                        	<!--- end code --->
							<!--- end field group --->
							<cfif getFG eq "x>">
								</FIELDSET>
								<br/>
							</cfif>
							<!---//---->
						</cfloop>
					</div>
					<div class="FormBotton">
						<cfset itemPos=0>
						<cfloop list="#Attributes.HiddenInputs#" delimiters="," index="hInput" >
							<cfset itemPos=itemPos+1>
							<cfset fName = trim(ListGetAt(Attributes.HiddenInputs,itemPos,','))>
							<cfset fValue = trim(ListGetAt(Attributes.HiddenInputValues,itemPos,','))>
							<input name="#fName#" type="hidden" id="#fName#" value="#fValue#" />
						</cfloop>
						<cfif Attributes.FormType eq "Add">
							<label>Add Another Record
							<input name="AddAnother" <CFIF structkeyexists(form,'AddAnother')>checked="checked"</cfif> type="checkbox" />
							</label>
						</cfif>
						<input name="#PostBackName#" type="hidden" id="#PostBackName#" value="Record" />
						<input type="submit" name="#Attributes.FormType#" value="#Attributes.SubmitTextValue#"/>
						<cfif not Attributes.DisableCancel><input name="cancel" type="button" onclick="javascript:history.go(-1);" value="Cancel" /></cfif>
					</div></td>
			</tr>
		</table>
		</cfform>
		<cfif not Attributes.RunToEnd>
			<cfif structkeyexists(form,PostBackName)>
				<cfif not(structkeyexists(form,'addanother'))>
					<cflocation addtoken="no" url="#Attributes.RedirectURL#" >
				</cfif>
			</cfif>
		</cfif>
	</cfoutput>
	<cfelse>
	<!--- the tag is Ending --->
	<!--- Focus the first field --->
	<script language="JavaScript" type="text/javascript">
			for(var i = 0; i < document.forms[0].elements.length; i++)	{
				if(document.forms[0].elements[i].type != "hidden")	{
					document.forms[0].elements[i].focus();
					break;
				}
			}
		</script>
</cfif>
