<!---//--------------------------------------------------------------------
	Name:		LogEvent.cfm
	Author:		Arowolo Michael .A.
	Created:	12/08/2007
	Updated:	12/08/2007
	Copyright:	(c) 2008	
	Purpose:	To Log Event about the system
	Code-Type:  Tag
	
	use: [Parameter-Name][data-type][requred][required-Parameter-Name][default-value]	-	[description][example]
	SolutionName[string][yes]		-	the name of the solution that raise the event[CORE]
	LogType[string][yes]			-	the type of Log[Information]
	LogTitle[string][yes]			-	the Title of the Event Log[Adding Customer Profile]
	LogDescription[string][no]		- 	the description of the log
	
	Dependencies: [Dependency-Name][Type]				-	[Description]
	application.conn.RunQuery(SQL statement)[function]	-	Execuit SQL Statements
	session.userid[data-type][integer]					-	holds the id of the current user
---------------------------------------------------------------------//--->
<cfif ThisTag.ExecutionMode EQ "Start">
	<cfparam name="Attributes.SolutionName" type="string">
	<cfparam name="Attributes.LogType" type="string" default="Application">
	<cfparam name="Attributes.LogTitle" type="string" >
	<cfparam name="Attributes.LogDescription" type="string" default="">
    
    <cfquery datasource="#application.dsn#">
        INSERT INTO core_log	( SolutionName, LogType, LogTitle,
        	LogDescription, SystemInfo, UserId)    
        VALUES (
        	<cfqueryparam cfsqltype="cf_sql_varchar" value="#Attributes.SolutionName#" >,
            <cfqueryparam cfsqltype="cf_sql_varchar" value="#Attributes.LogType#">,
            <cfqueryparam cfsqltype="cf_sql_varchar" value="#Attributes.LogTitle#">,
            <cfqueryparam cfsqltype="cf_sql_varchar" value="#Attributes.LogDescription#">,
            <cfqueryparam cfsqltype="cf_sql_varchar" value="#getSystemInfo()#">,
            <cfqueryparam cfsqltype="cf_sql_integer" value="#request.UserId#">
        )	
    </cfquery> 
	<!--- end the Tag ---> 
	<cfelse>
</cfif>
<!--- LogEvent function --->
<cffunction name="getSystemInfo" access="public" returntype="string">
	<cfset info = "Browser Agent : #replacenocase(cgi.HTTP_USER_AGENT,';', ',','all')# <br />">
	<cfset info = "#info# IP Address : #cgi.REMOTE_ADDR# <br />">
	<cfset info = "#info# URL : #cgi.SCRIPT_NAME#?#cgi.QUERY_STRING#">
	<cfreturn info>
</cffunction>
